unit menus;
interface

procedure radio(x,y,gen,c:word;text:string);
function dialog(text:string):string;
procedure puton(x,y,uz,gen,dur,size:word;text:string);
procedure mpad;
procedure izgara(x,y,uz:word);
procedure blk(x,y:word);
PROCEDURE display;
procedure hiscr;
procedure ldgm;
procedure help;
procedure savegm;
procedure sound;
procedure game;
procedure options;
procedure man;

implementation

uses manager,graph,grutil,crt,play;

var t:boolean;
    a:char;

procedure radio(x,y,gen,c:word;text:string);
begin
     case c of
     0:begin
     setfillstyle(1,num[8]);
     bar(x,y,x+gen,y+20);
     color(14);
     setlinestyle(0,0,1);
     settextstyle(2,0,5);
     settextjustify(centertext,centertext);
     outtextxy(x+gen div 2,y+10,text);
     color(15);
     line(x,y,x+gen,y);
     line(x,y,x,y+20);
     setcolor(0);
     line(x,y+20,x+gen,y+20);
     line(x+gen,y+20,x+gen,y);
     end;

     1:begin
            color(14);
            setlinestyle(0,0,1);
            rectangle(x-3,y-3,x+gen+3,y+23);
       end;

     2:begin
     setfillstyle(1,num[10]);
     bar(x,y,x+gen,y+20);
     color(12);
     setlinestyle(0,0,1);
     settextstyle(2,0,5);
     settextjustify(centertext,centertext);
     outtextxy(x+gen div 2+2,y+10,text);
     color(0);
     line(x,y,x+gen,y);
     line(x,y,x,y+20);
     setcolor(15);
     line(x,y+20,x+gen,y+20);
     line(x+gen,y+20,x+gen,y);
     end;

     3:begin
            color(8);
            setlinestyle(0,0,1);
            rectangle(x-3,y-3,x+gen+3,y+23);
       end;

end;
end;

function dialog(text:string):string;
const x=180;
y=200;
gen=270;
var c:word;
d:string[10];
begin
     setfillstyle(1,num[8]);
     bar(x,y,x+gen,y+100);
     color(14);
     setlinestyle(0,0,1);
     settextstyle(2,0,5);
     settextjustify(centertext,centertext);
     outtextxy(x+gen div 2,y+10,text);
     setfillstyle(1,0);
     bar(x+10,y+38,x+gen-10,y+58);
     color(15);
     line(x,y,x+gen,y);
     line(x,y,x,y+100);
     line(x+10,y+58,x+gen-10,y+58);
     line(x+gen-10,y+58,x+gen-10,y+38);
     setcolor(0);
     line(x,y+100,x+gen,y+100);
     line(x+gen,y+100,x+gen,y);
     textcolor(lightgreen);
     window(28,16,50,16);
     gotoxy (28,16);
     readln(d);
     window(1,1,80,25);
     dialog:=d;
     end;

procedure puton(x,y,uz,gen,dur,size:word;text:string);
begin
case dur of
     1:begin setfillstyle(1,num[8]);color(15);uz:=uz div 2;gen:=gen div 2;
             fillellipse(x-uz,y,gen,uz);
             setlinestyle(0,1,3);
             ellipse(x-uz-1,y,20,200,gen,uz);
             color(0);ellipse(x-uz,y,200,20,gen,uz);{ellipse(x-uz,y+1,200,20,gen,uz);}
             settextjustify(centertext,centertext);
             settextstyle(1,0,size);
             {outtextxy(x-uz+2,y-2,text);}
             color(14);outtextxy(x-uz,y-4,text);color(8);
             ellipse(x-uz-1,y+1,0,0,gen+2,uz+2)
       end;
     0:begin setfillstyle(1,num[8]);color(0);uz:=uz div 2;gen:=gen div 2;
             fillellipse(x-uz,y,gen,uz);
             setlinestyle(0,1,3);
             ellipse(x-uz-1,y+1,20,200,gen,uz);ellipse(x-uz+1,y+1,20,200,gen,uz);
             color(15);ellipse(x-uz,y,200,20,gen,uz);{ellipse(x-uz,y+1,200,20,gen,uz);}
             settextjustify(centertext,centertext);
             settextstyle(1,0,size);
             {color(0);outtextxy(x-uz+4,y-2,text);}
             color(14);outtextxy(x-uz+4,y-4,text);
             COLOR(13);
             ellipse(x-uz-1,y+1,0,0,gen+2,uz+2)
       end;

end;
end;

procedure mpad;
begin
setfillstyle(1,num[8]);
bar(100,20,540,460);color(8);
fillellipse(100,60,40,40);
fillellipse(540,60,40,40);
fillellipse(100,420,40,40);
fillellipse(540,420,40,40);
bar(60,60,100,420);
bar(540,60,580,420);
color(15);
setlinestyle(0,1,3);
arc(100,60,90,180,40);
arc(540,60,0,90,40);
arc(100,420,180,225,40);
line(60,60,60,420);
line(100,20,540,20);
color(0);
arc(100,420,225,270,40);
arc(540,420,270,360,40);
arc(540,60,0,45,40);
line(100,460,540,460);
line(580,60,580,420);
end;

procedure izgara(x,y,uz:word);
begin
setlinestyle(0,1,1);
color(0);
line(x,y,x+uz,y);
line(x,y,x,y+7);
color(15);
line(x+1,y+7,x+uz,y+7);
line(x+uz,y,x+uz,y+7);
setfillstyle(1,13);
bar(x+2,y+2,x+uz-2,y+5);
end;

procedure blk(x,y:word);
begin
putimage(x,y,blocks[4]^,0);
end;

procedure help;
function txt(cn:char):string;
begin
case cn of
#64..#70,#74,#76,#78,#84..#90:txt:=cn;
#97..#122:txt:=upcase(cn);
#135..#168:txt:=buyuk(cn);
#32:txt:='Space';
#27:txt:='ESC';
#73:txt:='Page up';
#81:txt:='Page down';
#82:txt:='Insert';
#83:txt:='Delete';
#71:txt:='Home';
#79:txt:='End';
#9:txt:='TAB';
#13:txt:='Enter';
#80:txt:='Down';
#77:txt:='Right';
#75:txt:='Left';
#72:txt:='Up';
end;
end;

begin
mpad;
settextjustify(0,1);
color(14);
settextstyle(1,0,1);
outtextxy(70,40,' CHECK-UP HELP ');
settextstyle(1,0,7);
outtextxy(155,260,'CHECK-UP');
settextstyle(1,0,1);
outtextxy(235,300,'by Sertan Yaman');
color(1);
outtextxy(185,330,'Copyright (C) 1998 Turkiye');
outtextxy(155,360,'"Tuzla Anadolu Teknik Lisesi" Labs');
outtextxy(200,390,'Written in Turbo Pascal');


color(12);
settextstyle(2,0,7);
outtextxy(110,80,'GAME CONTROLS');
settextstyle(2,0,6);
color(9);
outtextxy(100,110,'ROTATE ...:  '+txt(con.scnt[7]));
outtextxy(100,130,'LEFT ...:  '+txt(con.scnt[4]));
outtextxy(100,150,'RIGHT ...:  '+txt(con.scnt[6]));
outtextxy(100,170,'DOWN ...:  '+txt(con.scnt[5]));
outtextxy(100,190,'PAUSE ...:  '+txt(con.scnt[2]));
color(12);
settextstyle(2,0,7);
outtextxy(325,80,'PROGRAM CONTROLS');
settextstyle(2,0,6);
color(9);
outtextxy(335,110,'SAVE GAME ...:  F2');
outtextxy(335,130,'LOAD GAME ...:  F3');
outtextxy(335,150,'ROTATE REVERSE:  F5');
outtextxy(335,170,'QUICK SAVE ...:  F6');
outtextxy(335,190,'QUIT ...:  '+txt(con.scnt[3]));
outtextxy(335,210,'FAST QUIT ...:  '+txt(con.scnt[1]));
settextjustify(1,1);
end;

PROCEDURE display;
var a:char;
    s:array[1..10] of string[10];
    sec,pal:byte;

          procedure back;
          var tx,ty:word;
          begin
          setfillstyle(1,num[con.srenk[1]]);
          bar(252,42,548,338);
          if con.srndln then begin
          randomize;
          setlinestyle(0,0,1);
          for i:=1 to 500 do begin
             color(random(15));
             tx:=random(290);
             ty:=random(280);
             line(252+tx,42+ty,252+tx,42+ty+random(20));
             end;
             end;
          end;

          procedure texts;
          begin
          color(con.srenk[5]);
          settextstyle(1,0,4);
          outtextxy(395,120,'TETRIS');
          end;

          procedure bk(x,y:word);
          begin
          setfillstyle(1,num[con.srenk[4]]);
          bar(x,y,x+14,y+14);
          setfillstyle(1,num[con.srenk[4]+8]);
          bar(x+4,y+4,x+10,y+10);
          setlinestyle(0,0,1);
          color(15);
          line(x,y,x+14,y);
          line(x,y,x,y+14);
          setcolor(0);
          line(x,y+14,x+14,y+14);
          line(x+14,y+14,x+14,y);
          end;

          Procedure blks;
          begin
          bk(350,250);
          bk(350,265);
          bk(350,280);
          bk(365,280);

          bk(426,250);
          bk(426,265);
          bk(426,280);
          bk(411,280);

          bk(388,220);
          bk(388,235);
          bk(388,250);
          bk(403,235);
          bk(373,235);
          end;

          procedure playdome;
          begin
          setfillstyle(1,num[con.srenk[2]]);
          bar(310,50,480,330);
          if con.srndfrm then begin
                             randomize;
                             setlinestyle(0,0,1);
                             for i:=1 to 20 do  begin
                                 color(random(14));
                                 rectangle(310+i,50+i,480-i,330-i);
                                 end;
                             end;
          setfillstyle(1,num[con.srenk[3]]);
          bar(330,70,460,310);
          color(15);
          setlinestyle(0,0,1);
          line(310,50,310,330);
          line(310,50,480,50);
          line(330,310,460,310);
          line(460,310,460,70);
          setcolor(0);
          line(310,330,480,330);
          line(480,330,480,50);
          line(330,70,460,70);
          line(330,70,330,310);
          blks;
          texts;
          end;

          procedure full;
          begin
               back;
               playdome;
               color(15);
               setlinestyle(0,0,1);
               line(250,340,550,340);
               line(550,340,550,40);
               color(0);
               line(250,40,250,340);
               line(250,40,550,40);
          end;

          procedure secme;
          begin
          case sec of
               1:begin con.srenk[1]:=pal;full end;
               2:begin con.srenk[2]:=pal;playdome end;
               3:begin con.srenk[3]:=pal;playdome end;
               4:begin con.srenk[4]:=pal;blks end;
               5:begin con.srenk[5]:=pal;texts end;
               6:begin con.srenk[6]:=pal; end;

          end;

          end;

          procedure palet;
          begin
          for i:=0 to 15 do begin
              setfillstyle(1,num[i]);
              bar(250+i*19,350,250+i*19+14,400);
              end;
          end;
          procedure secpalet(c:byte);
          begin
               setlinestyle(0,1,3);
               color(8);

               for i:=0 to 15 do rectangle(248+i*19,348,247+i*19+19,402);
               color(15);
               if c<16 then rectangle(248+c*19,348,248+c*19+18,402);

          end;

procedure ausec;
var sc:byte;
          begin
case sec of
                    1,2:begin pal:=con.srenk[sec];secpalet(pal) end;
                    3,5:begin setfillstyle(1,num[8]);
                  bar(246,403,553,453);pal:=con.srenk[sec];secpalet(pal) end;
                    6:begin pal:=con.srenk[6];palet;secpalet(pal) end;
                    4:begin secpalet(con.srenk[4]);
                            if con.sblkorg then radio(250,405,300,2,'Use original colors')
                                       else radio(250,405,300,0,'Use original colors');
                            if con.sblkrnd then radio(250,430,300,2,'Use randomize colors')
                                       else radio(250,430,300,0,'Use randomize colors');
                                       sc:=1;
                    end;
        7:begin  setfillstyle(1,num[8]);
                  bar(246,342,553,453);
                  if con.srndln then radio(250,365,300,2,'ON')
                                else radio(250,365,300,0,'OFF');
           end;
         8:begin  setfillstyle(1,num[8]);
                  bar(246,342,553,453);
                  if con.srndfrm then radio(250,365,300,2,'ON')
                                else radio(250,365,300,0,'OFF');
           end;
         9:begin setfillstyle(1,num[8]);
                  bar(246,342,553,453);
         end;

         10:begin setfillstyle(1,num[8]);
                  bar(246,342,553,453);
         end;

          end;

end;

begin
setdef;
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;
mpad;
sec:=1;
pal:=0;
s[1]:='Background';
s[2]:='Foreground';
s[3]:='Playground';
s[4]:='Blocks';
s[5]:='Texts';
s[6]:='Score brd';
s[7]:='Rnd lines';
s[8]:='Rnd frame';
s[9]:='Default';
s[10]:='Accept';
puton(160,50,30,150,0,1,s[1]);
for i:=2 to 10 do puton(160,50+(i-1)*40,30,150,1,1,s[i]);
palet;
full;
repeat
repeat
a:=readkey;
until a in [#80,#77,#72,#75,#32,#27,#13,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
   #80 : begin if sec<>10 then begin
               puton(160,50+(sec-1)*40,30,150,1,1,s[sec]);sec:=sec+1;
               puton(160,50+(sec-1)*40,30,150,0,1,s[sec]);a:=#0 end;
          ausec;
          end;

   #72 : begin if sec<>1 then begin
            puton(160,50+(sec-1)*40,30,150,1,1,s[sec]);sec:=sec-1;
            puton(160,50+(sec-1)*40,30,150,0,1,s[sec]);a:=#0 end;
            ausec;
            end;

     #77:if sec<7 then begin if pal<15 then begin pal:=pal+1;secpalet(pal) end
                    else if sec<>4 then begin pal:=0;secpalet(pal) end
                                   else
          begin case pal of
                        15:begin pal:=16;secpalet(pal);radio(250,405,300,1,'') end;
                        16:begin radio(250,405,300,3,'');
                        radio(250,430,300,1,'');pal:=17 end;
                        17:begin  radio(250,430,300,3,'');pal:=0;secpalet(pal);end;
                        end;
          end;
          a:=#0;
          if sec=4 then if pal<16 then secme;
          if (sec<7) and (sec<>4) then secme;
          end;

     #75:if sec<7 then begin if (pal<>0) and (pal<16) then begin pal:=pal-1;secpalet(pal) end
                   else begin if sec=4 then
                   begin if pal=16 then begin palet;
                   radio(250,405,300,3,'Use original colors');pal:=15;
                   secpalet(pal); end
                                  else begin
            case pal of
            17:begin radio(250,430,300,3,'');
                     radio(250,405,300,1,'');pal:=16 end;
            0:begin pal:=17;secpalet(pal);radio(250,430,300,1,'');
                     radio(250,405,300,3,'');pal:=17 end;
            end;
                                        end;
            end
            else begin
                 pal:=15;secpalet(pal);
                 end;
                 end;
            if sec=4 then if pal<16 then secme;
            if (sec<7) and (sec<>4) then secme;
                   a:=#0;
                   end;

     #32:begin case sec of
              7:if con.srndln then begin radio(250,365,300,0,'OFF');con.srndln:=false;full end
                              else begin radio(250,365,300,2,'ON');con.srndln:=true;full end;

              8:if con.srndfrm then begin radio(250,365,300,0,'OFF');con.srndfrm:=false;playdome end
                              else begin radio(250,365,300,2,'ON');con.srndfrm:=true;playdome end;


              4:begin case pal of
                           16:if con.sblkorg then begin  radio(250,405,300,0,'Use original colors');
                                  con.sblkorg:=false;con.sblocktype:=0;
                      end

                      else begin con.sblkorg:=true;con.sblocktype:=1;
                                con.sblkrnd:=false;
                                radio(250,405,300,2,'Use original colors');
                                 radio(250,430,300,0,'Use randomize colors');
                      end;

         17:if con.sblkrnd then begin  radio(250,430,300,0,'Use randomize colors');
                                  con.sblkrnd:=false;con.sblocktype:=0;
                      end

                      else begin con.sblkrnd:=true;con.sblocktype:=2;
                                 con.sblkorg:=false;
                                radio(250,405,300,0,'Use original colors');
                                 radio(250,430,300,2,'Use randomize colors');
                      end;

         end;
         end;
         end;
              a:=#0;
              end;

     #13:begin case sec of
            9:begin
                      with con do
                           begin
                           srndln:=true;
                           srndfrm:=true;
                           srenk[1]:=1;
                           srenk[2]:=8;
                           srenk[3]:=7;
                           srenk[4]:=4;
                           srenk[5]:=4;
                           srenk[6]:=0;
                           end;
                           full;
            end;
            7:if con.srndln then begin radio(250,365,300,0,'OFF');con.srndln:=false;full end
                              else begin radio(250,365,300,2,'ON');con.srndln:=true;full end;

            8:if con.srndfrm then begin radio(250,365,300,0,'OFF');con.srndfrm:=false;playdome end
                              else begin radio(250,365,300,2,'ON');con.srndfrm:=true;playdome end;
            10:options;
           end;
           a:=#0;
           end;


     #27:options;
end;
until 1=2;
END;

procedure hiscr;
var a:char;
s:string[50];
procedure cercev(x,y,dx,dy:word);
begin
color(0);
setlinestyle(0,0,1);
line(x,y,dx,y);
line(x,y,x,dy);
color(15);
line(x,dy,dx,dy);
line(dx,dy,dx,y);
end;

begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;
mpad;
cercev(80,93,190,450);
cercev(200,93,290,450);
cercev(300,93,380,450);
cercev(390,93,570,450);
cercev(80,70,190,90);
cercev(200,70,290,90);
cercev(300,70,380,90);
cercev(390,70,570,90);
color(14);
settextstyle(2,0,6);
settextjustify(centertext,centertext);
outtextxy(320,50,' HI-SCORES ');
outtextxy(135,75,'Name');
outtextxy(245,75,'Score');
outtextxy(340,75,'Time');
outtextxy(470,75,'Date');
color(10);
for i:=1 to 9 do begin
str(score[i].hscore,s);
outtextxy(135,60+i*40,score[i].hname);
outtextxy(245,60+i*40,s);
outtextxy(340,60+i*40,score[i].htime);
outtextxy(480,60+i*40,score[i].hdate);
end;
repeat until keypressed;
flushkb;
man;
end;

procedure ldgm;
var a:char;
sec,pal:byte;
begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;
mpad;
color(4);
settextstyle(1,0,5);
settextjustify(centertext,centertext);
outtextxy(320,50,'LOAD GAME');
sec:=con.slsave;
if sec=0 then sec:=1;
for i:=1 to 9 do begin
radio(165,100+(i-1)*40,300,0,saves[i].savname);
end;
radio(165,100+(sec-1)*40,300,2,saves[sec].savname);
repeat
repeat
a:=readkey;
until a in [#80,#72,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<9 then begin
     radio(165,100+(sec-1)*40,300,0,saves[sec].savname);sec:=sec+1;
     radio(165,100+(sec-1)*40,300,2,saves[sec].savname);a:=#0 end;

     #72:if sec<>1 then begin
     radio(165,100+(sec-1)*40,300,0,saves[sec].savname);sec:=sec-1;
     radio(165,100+(sec-1)*40,300,2,saves[sec].savname);a:=#0 end;
     #27:man;
     #13:begin don:=saves[sec].sdon;x:=saves[sec].sx;y:=saves[sec].sy;
                   name:=saves[sec].sname;
                     for i:=23 downto 0 do
                      for j:=1 to 11 do begin
                      alan[j,i]:=saves[sec].salan[j,i];
                      renkler[j,i]:=saves[sec].srenkler[j,i];
                      end;
                      cdel:=saves[sec].scdel;
                      puan:=saves[sec].spuan;
                      con.rotate:=saves[sec].srotate;
                      tasnum:=saves[sec].stasnum;
                      nextblock:=saves[sec].snextblock;
                      FLUSHKB;
                      playing(true);
                      SETDEF;
                      man;
                   end;

end;
until 1=2;
END;

procedure savegm;
var a:char;
sec,pal:byte;

begin
mpad;
color(4);
settextstyle(1,0,5);
settextjustify(centertext,centertext);
outtextxy(320,50,'SAVE GAME');
sec:=con.slsave;
if sec=0 then sec:=1;
for i:=1 to 9 do begin
radio(165,100+(i-1)*40,300,0,saves[i].savname);
end;
radio(165,100+(sec-1)*40,300,1,saves[sec].savname);
repeat
repeat
a:=readkey;
until a in [#80,#72,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<9 then begin
     radio(165,100+(sec-1)*40,300,3,saves[sec].savname);sec:=sec+1;
     radio(165,100+(sec-1)*40,300,1,saves[sec].savname);a:=#0 end;

     #72:if sec<>1 then begin
     radio(165,100+(sec-1)*40,300,3,saves[sec].savname);sec:=sec-1;
     radio(165,100+(sec-1)*40,300,1,saves[sec].savname);a:=#0 end;
     #27:exit;
     #13:begin
                   radio(165,100+(sec-1)*40,300,2,'');
                   with saves[sec] do begin
                   savname:=dialog('Enter A Name');
                   if savname='' then saves[sec].savname:='NoName';
                   sdon:=don;sx:=x;sy:=y;
                   sname:=name;
                     for i:=23 downto 0 do
                      for j:=1 to 11 do begin
                      salan[j,i]:=alan[j,i];
                      srenkler[j,i]:=renkler[j,i];
                      end;
                      spuan:=puan;
                      srotate:=con.rotate;
                      stasnum:=tasnum;
                      nextblock:=nextblock;
                   end;
                   con.slsave:=sec;
                   gamesaved:=true;
                   radio(165,100+(sec-1)*40,300,2,saves[sec].savname);
                   radio(165,100+(sec-1)*40,300,1,saves[sec].savname);
                                   flushkb;
                                   exit;
     end;
end;
until 1=2;
END;

procedure sound;
var sec,pal:byte;
    s:array [1..3] of string[50];
label son;
    procedure secc;
    begin
    if sec<4 then begin
    for i:=1 to 3 do radio(120,20+i*80,400,0,s[i]);
    radio(120,20+sec*80,400,2,s[sec]);
    con.ssndtype:=sec-1;
    a:=#0;
    end;
    end;
begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;
s[1]:='SOUND BLASTER 16 (220Hex)';
s[2]:='COMPUTER BEEPER (BEEP!!, BEEP!!, BEEP!!)';
s[3]:='NONE OF THEM (not Recommended!!)';
sec:=1;
mpad;
for i:=1 to 9 do izgara(75,300+i*15,120);
for i:=1 to 9 do izgara(445,300+i*15,120);
radio(120,100,400,0,s[1]);
radio(120,100,400,1,s[1]);
radio(120,180,400,0,s[2]);
radio(120,260,400,0,s[3]);
puton(340,350,40,200,1,3,'Test Settings');
puton(340,410,40,200,1,3,'Accept');
case con.ssndtype of
0:radio(120,100,400,2,s[1]);
1:radio(120,180,400,2,s[2]);
2:radio(120,260,400,2,s[3]);
end;
repeat
repeat
if pal<>63 then pal:=pal+1 else pal:=0;
if keypressed then a:=readkey;
setrgbpalette(num[13],pal,0,0);
delay(4);
until a in [#80,#72,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:begin if sec <3 then begin radio(120,20+sec*80,400,3,s[sec]);sec:=sec+1;a:=#0;
               radio(120,20+sec*80,400,1,s[sec]); end
                    else
                    case sec of
                     3:begin radio(120,260,400,3,s[3]);
                             puton(340,350,40,200,0,3,'Test Settings');
                             sec:=4;
                     end;

                     4:begin puton(340,350,40,200,1,3,'Test Settings');;
                             puton(340,410,40,200,0,3,'Accept');
                             sec:=5;
                       end;
                     end;
     a:=#0;
     end;

     #72:begin if not (sec in [1,5,4]) then begin
               radio(120,20+sec*80,400,3,s[sec]);sec:=sec-1;
               radio(120,20+sec*80,400,1,s[sec]); end
               else case sec of
               5:begin puton(340,350,40,200,0,3,'Test Settings');
                             puton(340,410,40,200,1,3,'Accept');
                             sec:=4;
               end;
               4:begin puton(340,350,40,200,1,3,'Test Settings');
                       radio(120,260,400,1,s[3]);
                       sec:=3;
                 end;
               end;
          a:=#0;
          end;
     #32:secc;
     #27:options;
     #13:case sec of
              1..3:secc;
              4:;
              5:options;
              end;


end;
until 1=2;
son:
end;

procedure game;
procedure gamemn;forward;

procedure control;
const
    dlx:array [1..7] of word=(200,280,360,180,230,280,500);
    dly:array [1..7] of word=(80,80,80,190,260,190,210);
    dlg:array [1..7] of word=(30,30,30,50,50,50,80);

var a:char;
    sb:array [1..7] of string[10];
    t:array [1..10] of string[10];
    s:array[1..3] of string[10];
    sec,pal:byte;
label son;

procedure mzr;forward;

procedure hlp(text:string);forward;

procedure def;
begin
 with con do
      begin
      scnt[1]:='Q';
      scnt[2]:=#13;
      scnt[3]:=#27;
      scnt[4]:=#75;
      scnt[5]:=#80;
      scnt[6]:=#77;
      scnt[7]:=#32;
      end;
      Hlp('Default keys loaded !!!');
  mzr;
end;

procedure hlp(text:string);
var x,y,gen:word;
begin
x:=120;y:=360;gen:=400;
bar(x,y,x+gen,y+20);
 setfillstyle(1,1);
 bar(x+2,y+2,x+gen-2,y+18);
     color(10);
     setlinestyle(0,0,1);
     settextstyle(2,0,5);
     settextjustify(1,1);
     outtextxy(x+gen div 2,y+10,text);
     color(0);
     line(x,y,x+gen,y);
     line(x,y,x,y+20);
     setcolor(15);
     line(x,y+20,x+gen,y+20);
     line(x+gen,y+20,x+gen,y);
          settextjustify(1,1);
 end;


procedure txtbk(sc:byte;c:char);
var gen,x,y:word;
    text:string[10] ;

function txt(cn:char):string;
begin
case cn of
#64..#70,#74,#76,#78,#84..#90:txt:=c;
#97..#122:txt:=upcase(c);
#135..#168:txt:=buyuk(c);
#32:txt:='Space';
#27:txt:='ESC';
#73:txt:='Page up';
#81:txt:='Page down';
#82:txt:='Insert';
#83:txt:='Delete';
#71:txt:='Home';
#79:txt:='End';
#9:txt:='TAB';
#13:txt:='Enter';
#80:txt:='Down';
#77:txt:='Right';
#75:txt:='Left';
#72:txt:='Up';
end;
end;

begin
text:=txt(c);
gen:=100;
setfillstyle(1,num[8]);
case sc of
   1:begin
   x:=dlx[sc]-100;
   y:=dly[sc]+20;
   end;
    2:begin
   x:=dlx[sc]-70;
   y:=dly[sc]+20;
   end;
    3:begin
   x:=dlx[sc]-40;
   y:=dly[sc]+20;
   end;

     4:begin
   x:=dlx[sc]-110;
   y:=dly[sc]+30;
     end;

      6:begin
   x:=dlx[sc]-40;
   y:=dly[sc]+30;
     end;

     5:begin
   x:=dlx[sc]-75;
   y:=dly[sc]+40;
       end;

     7:begin
   x:=dlx[sc]-90;
   y:=dly[sc]+50;
       end;
     end;

 bar(x,y,x+gen,y+20);
 setfillstyle(1,0);
 bar(x+2,y+2,x+gen-2,y+18);
     color(10);
     setlinestyle(0,0,1);
     settextstyle(2,0,5);
     settextjustify(centertext,centertext);
     outtextxy(x+gen div 2,y+10,text);
     color(0);
     line(x,y,x+gen,y);
     line(x,y,x,y+20);
     setcolor(15);
     line(x,y+20,x+gen,y+20);
     line(x+gen,y+20,x+gen,y);

end;

procedure mzr;
begin
for i:=1 to 7 do BEGIN puton(dlx[i],dly[i],dlg[i],dlg[i],1,1,sb[i]);
                       txtbk(i,con.scnt[i]);
                       end;
setlinestyle(0,0,1);
end;

procedure cust;
var sc:byte;
label ennd;
begin
sc:=1;
puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],0,3,sb[SC]);
hlp('Use Arrow Left-Right to move');
repeat
repeat
a:=readkey;
until a in [#75,#77,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of

     #77:if SC<7 then begin
     hlp('To define the key press "Enter"');
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],1,3,sb[SC]);
     SC:=SC+1;
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],0,3,sb[SC]);
     a:=#0;
     end;

     #75:if SC<>1 then begin
          hlp('To define the key press "Enter"');
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],1,3,sb[SC]);
     SC:=SC-1;
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],0,3,sb[SC]);
     a:=#0;
     end;

     #27:begin mzr;goto ennd;end;

     #32,#13:begin
     hlp('Now press a key');
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],1,3,sb[SC]);
     txtbk(sc,'');
     flushkb;
     repeat
     a:=readkey;
     until a<>#0;
     hlp('Thats OK!!!');
     puton(dlx[SC],dly[SC],dlg[SC],dlg[SC],0,3,sb[SC]);
     txtbk(sc,a);
     con.scnt[sc]:=a;
     a:=#0;
     end;

end;
until 1=2;
ennd:
END;

begin
{for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;}
 sb[1]:='N';
 sb[2]:='P';
 sb[3]:='Q';
 sb[4]:='L';
 sb[5]:='D';
 sb[6]:='R';
 sb[7]:='Rotate';
mpad;
mzr;
sec:=1;
s[1]:='DEFAULT';
s[2]:='CUSTOM';
s[3]:='ACCEPT';
for i:=1 to 3 do puton(165+(i-1)*180,420,50,150,1,3,s[i]);
puton(165,420,50,150,0,3,s[1]);
 hlp('Loads the default keys');
repeat
repeat
a:=readkey;
until a in [#77,#75,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of

     #77:if sec<3 then begin
     puton(165+(sec-1)*180,420,50,150,1,3,s[sec]);
     sec:=sec+1;
     puton(165+(sec-1)*180,420,50,150,0,3,s[sec]);
     a:=#0;
      end;

     #75:if sec>1 then begin
     puton(165+(sec-1)*180,420,50,150,1,3,s[sec]);
     sec:=sec-1;
     puton(165+(sec-1)*180,420,50,150,0,3,s[sec]);
     a:=#0;
     end;
     #27:exit;

     #13:begin case sec of
              1:def;
              2:cust;
              3:gamemn;
              end;
              a:=#0;
              end;
end;
case sec of
    1: hlp('Loads the default keys');
    2: hlp('Customizes the control keys');
    3: hlp('Accept settings');
end;
until 1=2;
son: a:=#0;
END;


procedure diff;
var a:char;
s:array[1..5] of string[10];
sec,pal:byte;
label son;
begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;

mpad;
sec:=con.sdif;
s[1]:='EASY';
s[2]:='MEDIUM';
s[3]:='HARD';
s[4]:='EXPERT';
s[5]:='ACCEPT';
radio(165,100,300,0,s[1]);
for i:=1 to 4 do radio(165,100+(i-1)*60,300,0,s[i]);
radio(165,100+(sec-1)*60,300,1,s[sec]);
radio(165,100+(sec-1)*60,300,2,s[sec]);
puton(340,380,50,200,1,3,s[5]);

repeat
repeat
a:=readkey;
until a in [#80,#72,#13,#27,#32,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<4 then begin
     radio(165,100+(sec-1)*60,300,3,s[sec]);sec:=sec+1;
     radio(165,100+(sec-1)*60,300,1,s[sec]);a:=#0 end
     else begin puton(340,380,50,200,0,3,s[5]);sec:=5 end;

     #72:if sec<>1 then begin
     if sec=5 then puton(340,380,50,200,1,3,s[5]);
     radio(165,100+(sec-1)*60,300,3,s[sec]);sec:=sec-1;
     radio(165,100+(sec-1)*60,300,1,s[sec]);a:=#0 end;
     #27:man;
     #32:if sec<>con.sdif then begin for i:=1 to 4 do
     radio(165,100+(i-1)*60,300,0,s[i]);
            radio(165,100+(sec-1)*60,300,2,s[sec]);
                                     con.sdif:=sec;
                                     end;
     #13:case sec of
              1:;
              2:;
              3:;
              4:;
              5:gamemn;
              end;

end;
until 1=2;
son:
a:=#0;
END;

procedure gamemn;
var a:char;
s:array[1..5] of string[10];
sec,pal,sc:byte;
begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;
mpad;
sec:=1;
s[1]:='CONTROLS';
s[2]:='DIFFICULTY';
s[3]:='ACCEPT';
puton(340,180,50,300,0,3,s[1]);
for i:=2 to 3 do puton(340,180+(i-1)*80,50,300,1,3,s[i]);
repeat
repeat
if pal<>63 then pal:=pal+1 else pal:=0;
if keypressed then a:=readkey;
delay(10);
setrgbpalette(num[13],pal,0,0);
until a in [#80,#72,#13,#27,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<>3 then begin
     puton(340,180+(sec-1)*80,50,300,1,3,s[sec]);sec:=sec+1;
     puton(340,180+(sec-1)*80,50,300,0,3,s[sec]);a:=#0 end;
     #72:if sec<>1 then begin
     puton(340,180+(sec-1)*80,50,300,1,3,s[sec]);sec:=sec-1;
     puton(340,180+(sec-1)*80,50,300,0,3,s[sec]);a:=#0 end;
     #27:OPTIONS;
     #13:case sec of
              1:control;
              2:diff;
              3:options;
              end;


end;
until 1=2;
END;

begin
gamemn;
end;

procedure options;
var a:char;
s:array[1..5] of string[10];
sec,pal:byte;

begin
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;

mpad;
color(14);
settextjustify(3,3);
settextstyle(1,0,1);
outtextxy(330,40,' CHECK-UP OPTIONS ');
sec:=1;
s[1]:='GAME';
s[2]:='DISPLAY';
s[3]:='SOUND';
s[4]:='ACCEPT';
s[5]:='CANCEL';
puton(340,100,50,270,0,3,s[1]);
for i:=2 to 5 do puton(340,100+(i-1)*80,50,300-i*30,1,3,s[i]);
for i:=1 to 12 do begin izgara(90,70+i*30,30+i*7);
                        izgara(520-i*7,70+i*30,30+i*7);
                       end;
repeat
repeat
if pal<>63 then pal:=pal+1 else pal:=0;
if keypressed then a:=readkey;
delay(10);
setrgbpalette(num[13],pal,0,0);
until a in [#80,#72,#13,#27,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<>5 then begin
     puton(340,100+(sec-1)*80,50,300-sec*30,1,3,s[sec]);sec:=sec+1;
     puton(340,100+(sec-1)*80,50,300-sec*30,0,3,s[sec]);a:=#0 end;
     #72:if sec<>1 then begin
     puton(340,100+(sec-1)*80,50,300-sec*30,1,3,s[sec]);sec:=sec-1;
     puton(340,100+(sec-1)*80,50,300-sec*30,0,3,s[sec]);a:=#0 end;
     #27:man;
     #13:case sec of
              1:game;
              2:display;
              3:sound;
              4:man;
              5:begin yukle;man end;
              end;

end;
until 1=2;
END;



procedure man;
var a:char;
s:array[1..5] of string[10];
sec,pal:byte;

procedure kapa;
begin
qfadeout;
cik;
end;

begin
flushkb;
cleardevice;
setdef;
for i:=0 to 16 do
 for J:=0 to 24 do BEGIN blk(i*21,j*21);
                         blk(650-i*21,j*21);
                         END;

mpad;
settextjustify(centertext,centertext);
color(13);
settextstyle(1,0,7);
setusercharsize(6,2,3,2);
outtextxy(320,40,'CHECK-UP');
sec:=1;
s[1]:='NEW GAME';
s[2]:='LOAD GAME';
s[3]:='OPTIONS';
s[4]:='HI-SCORES';
s[5]:='QUIT';
puton(340,100,50,270,0,3,s[1]);
for i:=2 to 5 do puton(340,100+(i-1)*80,50,300-i*30,1,3,s[i]);
for i:=1 to 12 do begin izgara(90,70+i*30,30+i*7);
                        izgara(520-i*7,70+i*30,30+i*7);
                        end;
repeat
repeat
if pal<>63 then pal:=pal+1 else pal:=0;
if keypressed then a:=readkey;
delay(10);
setrgbpalette(num[13],pal,0,0);
until a in [#80,#72,#13,#27,con.scnt[1]];
if a=con.scnt[1] then cik;
case a of
     #80:if sec<>5 then begin
     puton(340,100+(sec-1)*80,50,300-sec*30,1,3,s[sec]);sec:=sec+1;
     puton(340,100+(sec-1)*80,50,300-sec*30,0,3,s[sec]);a:=#0 end;

     #72:if sec<>1 then begin
     puton(340,100+(sec-1)*80,50,300-sec*30,1,3,s[sec]);sec:=sec-1;
     puton(340,100+(sec-1)*80,50,300-sec*30,0,3,s[sec]);a:=#0 end;

     #13:begin
              CASE sec OF
              1:begin
              name:=dialog('Enter your name');
              if name='' then name:='Noname';
              playing(false);
              cleardevice;
              setdef;
              man;
              end;

              2:begin ldgm;
                            playing(true);
              cleardevice;
              setdef;
              man;
              end;

              3:options;
              4:hiscr;
              5:kapa;
         end;
         a:=#0;
         end;

     #27:kapa;
     end;
until 1=2;
end;
end.